# coding: utf-8

"""
    Edge Impulse API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by: https://openapi-generator.tech
"""


from __future__ import annotations
from inspect import getfullargspec
import pprint
import re  # noqa: F401
import json


from typing import Dict, Optional
from pydantic import BaseModel, Field, StrictInt, StrictStr
from edgeimpulse_api.models.ai_actions_data_category import AIActionsDataCategory

class AIActionsConfig(BaseModel):
    data_category: AIActionsDataCategory = Field(..., alias="dataCategory")
    data_metadata_key: Optional[StrictStr] = Field(None, alias="dataMetadataKey", description="Metadata key to filter on. Required if dataCategory is equal to \"dataWithoutMetadataKey\" or \"dataWithMetadata\".")
    data_metadata_value: Optional[StrictStr] = Field(None, alias="dataMetadataValue", description="Metadata value to filter on. Required if dataCategory is equal to \"dataWithMetadata\".")
    last_used_transformation_block_id: Optional[StrictInt] = Field(None, alias="lastUsedTransformationBlockId", description="The selected transformation block ID.")
    last_used_parameters: Optional[Dict[str, StrictStr]] = Field(None, alias="lastUsedParameters", description="Parameters for the transformation block. These map back to the parameters in OrganizationTransformationBlock 'parameters' property.")
    __properties = ["dataCategory", "dataMetadataKey", "dataMetadataValue", "lastUsedTransformationBlockId", "lastUsedParameters"]

    class Config:
        allow_population_by_field_name = True
        validate_assignment = False

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self,indent=None) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict(),indent=indent)

    @classmethod
    def from_json(cls, json_str: str) -> AIActionsConfig:
        """Create an instance of AIActionsConfig from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> AIActionsConfig:
        """Create an instance of AIActionsConfig from a dict"""
        if obj is None:
            return None

        if type(obj) is not dict:
            return AIActionsConfig.construct(**obj)

        _obj = AIActionsConfig.construct(**{
            "data_category": obj.get("dataCategory"),
            "data_metadata_key": obj.get("dataMetadataKey"),
            "data_metadata_value": obj.get("dataMetadataValue"),
            "last_used_transformation_block_id": obj.get("lastUsedTransformationBlockId"),
            "last_used_parameters": obj.get("lastUsedParameters")
        })
        return _obj

